Subject: Re: OF flat device tree for ppc32...

From: Dan Malek <[email-masked]>
Date: Thu, 19 May 2005 14:04:05 -0400

On May 19, 2005, at 11:37 AM, Jon Loeliger wrote:

> So, there were two positive comments that I received
> as feedback on my initial suggestion, and no negative
> comments.  (Minor patch deltas not withstanding.)

I have the same negative comments as Wolfgang.
This boot rom to kernel interface is continually discussed,
has been for years, and it just gets a little tiring :-)

The main reason for the original work done to create
the "boot wrapper" functions was to accommodate as
many boot roms as possible, distilled into a minimal
amount of common information.

We still have people (more and more, actually) that want
to run Linux and associated applications in minimal
flash and ram space.  Solutions that require more and
more code get to the point where they simply don't
fit into these systems.

There are also many embedded systems that don't
run something like U-Boot, and even if they did they
are not likely to perform field upgrades just to use
something that adds no value to their product.  We
must be able to accommodate these systems, as
the existing code does today.

Real embedded devices have minimalist requirements.
Minimal flash, minimal ram, minimal boot up time.  Even
today, Linux is too big and too slow for many of these
devices, making other alternatives more attractive.  If
we want to continue with success in this embedded
space, we have to address minimal requirement and
stop changing things to make them look like workstations.
We get spoiled by the few evaluation or demo boards we
see, because they are likely on the resource rich side.
Fine for development, but not something that will
see production.

We have embedded design wins today because of
the code we had years ago.  I'm afraid if we continue
with the code bloat and the performance challenges
we see with 2.6, we are going to lose many of the
new embedded products in the future.

If you consider yourself to be an embedded engineer,
you have to place "minimal resource use" at the top
of your list.  They have to boot and be useful "instantly."

Thanks.

	-- Dan